# vim:set encoding=utf-8:
###############################################################################
# Copyright:
#    2009 Clint Adams <schizo@debian.org>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The names of its contributors may not be used to endorse or promote
#    products derived from this software without specific prior written
#    permission.
#
# THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
# EVENT SHALL THE CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
###############################################################################

import urllib, urlparse, cgi

from BeautifulSoup import BeautifulSoup
from __init__ import *

def parse_table(soup, key):
    cell = soup.first('td', {'class':key})
    return cell.string

class RedmineData:
    def __init__(self, uri, id):
        soup = BeautifulSoup(urllib.urlopen(uri))

        self.id = id or failwith(uri, "Redmine: no id")
        self.status = parse_table(soup, 'status') or failwith(uri, "Redmine", exn=NoStatusExn)
        self.resolution = None

class RemoteRedmine(RemoteBts):
    def __init__(self, cnf):
        bugre  = r'^%(uri)s/issues/([0-9]+)$'
        urifmt = '%(uri)s/issues/%(id)s'
        RemoteBts.__init__(self, cnf, bugre, urifmt, RedmineData)

    def isClosing(self, status, resolution):
        return status in ('Closed',)

    def isWontfix(self, status, resolution):
        return status in ('Rejected',)

RemoteBts.register('redmine', RemoteRedmine)
